import pandas as pd
from datareaders import *
import scipy as sp
from sklearn.feature_extraction.text import TfidfVectorizer
from mymodel import *
from sklearn.feature_selection import SelectKBest, chi2
import nltk

#dataTRAC = TRACAggressionReader("./datasets/AggressionFB")
#dataGO = GaoReader("./datasets/GaoEtAl")
#dataKAGGLE = KaggleToxicJigsawReader("./datasets/KaggleToxicJigsaw")
#dataKOL = KolhatkarReader("./datasets/Kolhatkar")
#dataWas1 = WaseemNAACLReader("./datasets/WaseemHovyNAACL")
dataWas2 = WaseemNLPReader("./datasets/WaseemNLPaCSS")
#dataWul1 = WulczynReader("./datasets/WulczynAggression/4267550/aggression_annotated_comments.tsv", "./datasets/WulczynAggression/4267550/aggression_annotations.tsv", "aggression")
#dataWul2 = WulczynReader("./datasets/WulczynPersAttack/4054689/attack_annotated_comments.tsv", "./datasets/WulczynPersAttack/4054689/attack_annotations.tsv", "attack")
#dataWul3 = WulczynReader("./datasets/WulczynToxicity/4563973/toxicity_annotated_comments.tsv", "./datasets/WulczynToxicity/4563973/toxicity_annotations.tsv", "toxicity")

datasets_list = [(dataWas2, "Was2")]
#datasets_list = [(dataGO,"GO")]

l = nltk.stem.WordNetLemmatizer()

def preprocessing(s):
	return l.lemmatize(s.lower())

for data_train, data_train_ID in datasets_list:
    print("******* STARTING FOR TRAIN " + data_train_ID) 
    print("Calculating feats ...")
    tiv = TfidfVectorizer(analyzer = "word", ngram_range = (1,1), norm = None, use_idf = False, stop_words = 'english', preprocessor = preprocessing)
    train_data = tiv.fit_transform(data_train.train_texts)
    inv_vocab = {v: k for k, v in tiv.vocabulary_.items()}
    dev_data = tiv.transform(data_train.dev_texts)
    m = my_model()
    m.fit(train_data, data_train.train_labels, dev_data, data_train.dev_labels)
    coefs = m.clf.best_estimator_.coef_[0]
    feat_weights = [(inv_vocab[i], coefs[i]) for i in range(len(coefs))]
    feat_weights_sorted = sorted(feat_weights, key=lambda x: x[1], reverse=True)
    print(feat_weights_sorted[0:40])
    test_data = tiv.transform(data_train.test_texts)

    predictions  = pd.Series(m.predict(test_data))
    f1_classic = f1_score(y_true = data_train.test_labels, y_pred = predictions, pos_label = 1, average="binary")
    print("F1 classic :" + str(f1_classic))

    print()
    print()
    print()
    print()
    print()
   

 
