import pandas as pd
import numpy as np
from sklearn.metrics import f1_score
from stattest import *

datasets_list = ["KOL", "GO", "TRAC", "Was2", "Was1", "Wul1", "Wul2", "Wul3", "KAGGLE"]

for data_train_ID in datasets_list:
    print(data_train_ID, end = '')
    for data_aug_ID in datasets_list:
        output_filename = "P2_" + data_train_ID + "_vs_" + data_aug_ID + ".csv"
        output_data = pd.read_csv("./p2/" + output_filename, index_col = 0, header = None)
        
        correct_preds = np.array(output_data.iloc[:,0])
        model_preds = np.array(output_data.iloc[:,1])

        f1_augmented = f1_score(y_true = correct_preds, y_pred = model_preds, pos_label = 1, average="binary")
        print(" & %.3f" % f1_augmented, end = '')
        # statistical test
        orig_filename = "P1_" + data_train_ID + "_vs_" + data_train_ID + ".csv"
        orig_data = pd.read_csv("./p1/" + orig_filename, index_col = 0)
        baseline_preds = np.array(orig_data.iloc[:,1])
        
        c_low, c_up = bootstrap_test(correct_preds, model_preds, baseline_preds, 10000)
        significant = not (c_low <= 0 and c_up >=0)        
        print("(+)" if significant else "(-)", end = '')   
        
    print(" \\\\")



