import pandas as pd
from datareaders import *
import scipy as sp
from sklearn.feature_extraction.text import TfidfVectorizer
from mymodel import *
from sklearn.feature_selection import SelectKBest, chi2
import nltk

dataTRAC = TRACAggressionReader("./datasets/AggressionFB")
dataGO = GaoReader("./datasets/GaoEtAl")
dataKAGGLE = KaggleToxicJigsawReader("./datasets/KaggleToxicJigsaw")
dataKOL = KolhatkarReader("./datasets/Kolhatkar")
dataWas1 = WaseemNAACLReader("./datasets/WaseemHovyNAACL")
dataWas2 = WaseemNLPReader("./datasets/WaseemNLPaCSS")
dataWul1 = WulczynReader("./datasets/WulczynAggression/4267550/aggression_annotated_comments.tsv", "./datasets/WulczynAggression/4267550/aggression_annotations.tsv", "aggression")
dataWul2 = WulczynReader("./datasets/WulczynPersAttack/4054689/attack_annotated_comments.tsv", "./datasets/WulczynPersAttack/4054689/attack_annotations.tsv", "attack")
dataWul3 = WulczynReader("./datasets/WulczynToxicity/4563973/toxicity_annotated_comments.tsv", "./datasets/WulczynToxicity/4563973/toxicity_annotations.tsv", "toxicity")

datasets_list = [(dataTRAC, "TRAC"), (dataGO, "GO"), (dataKAGGLE, "KAGGLE"), (dataKOL, "KOL"), 
                (dataWas1, "Was1"), (dataWas2, "Was2"), (dataWul1, "Wul1"), (dataWul2, "Wul2"), 
                (dataWul3, "Wul3")]

for data, data_ID in datasets_list:
	print(data_ID)
	print(len(data.train_texts))
	print(len(data.dev_texts))
	print(len(data.test_texts))
	data_texts = pd.concat([data.train_texts, data.dev_texts, data.test_texts])
	data_labels = pd.concat([data.train_labels, data.dev_labels, data.test_labels])
	positive = data_labels[data_labels == 1]

	print(float(len(positive)) / float(len(data_labels)))
	print()
	print()
	print()
	print()
	print()
	
