import pandas as pd
from sklearn.metrics import f1_score

def bootstrap_test(correct, pred1, pred2, num_iter):
    if(len(pred1) != len(pred2)):
        raise Exception("Something is wrong the prediction sequences should be of equal length!")
    pop_size = len(pred1)
    indexes = pd.Series(range(pop_size))
    res = []
    for i in range(num_iter):
        iter_indexes = indexes.sample(pop_size, replace = True)
        pred1_sample = pred1[iter_indexes]
        pred2_sample = pred2[iter_indexes]
        correct_sample = correct[iter_indexes]
        f1_first = f1_score(y_true = correct_sample, y_pred = pred1_sample, pos_label = 1, average = "binary")
        f1_second = f1_score(y_true = correct_sample, y_pred = pred2_sample, pos_label = 1, average = "binary")
        #print(f1_first)
        #print(f1_second)
        #exit()

        res.append(f1_first - f1_second)
    res = sorted(res)
    conf_int_lower = res[int(len(res)*0.025)]
    conf_int_upper = res[int(len(res)*0.975)]
    return(conf_int_lower, conf_int_upper) 

